--- !ditz.rubyforge.org,2008-03-06/issue 
title: Handle resident_size context property.
desc: Libale currently has no handling for resident size.  This should probably be fixed eventually.
type: :task
component: libale
release: 
reporter: David Hilvert <dhilvert@auricle.dyndns.org>
status: :unstarted
disposition: 
creation_time: 2009-01-10 06:01:14.995003 Z
references: []

id: 76aa36a03fb8d5ab1fdfc54a23caeed859c97da1
log_events: 
- - 2009-01-10 06:01:26.950928 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - created
  - ""
- - 2009-02-13 22:37:42.709795 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    This could perhaps be addressed from within the OpenCL abstraction, as a
    special OpenCL device or otherwise.
- - 2009-02-13 22:42:56.622663 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    As an alternative to addressing implementation for this parameter from within
    the OpenCL abstraction, libale images could be stored as arrays of OpenCL
    buffers, with an OpenCL-language function or macro used for iterating the
    necessary combinations of input and output image segments.
- - 2009-02-13 23:00:08.793123 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    In the case that libale handles segments to satisfy resident_size, note that
    such segments could be generated internally to the library (e.g., splitting any
    larger buffers passed from client code).
- - 2009-02-14 10:38:56.911441 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note that segmentation of images could occur internally to the image type, and
    that this is probably the most natural approach to take.
- - 2009-02-14 10:50:53.339543 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note that, if segmentation occurs within the image type, such type could return
    an error value (e.g., ((cl_mem) 0)) from the standard return function, indicating
    that a special return function be used that is capable of returning arrays of
    OpenCL buffers.  Further, it might be acceptable, and perhaps appropriate, for
    images to accept client-specified buffers of arbitrary size, perhaps segmenting
    these, if such is desired, as well as to accept segmented buffers from the
    client.
- - 2009-02-25 11:33:40.355151 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note (cf. {issue cd8cda126db604feda8a481b2022490311624cb9}) that multiple properties resident_size should probably be
    tracked, in order to support a multi-level hierarchy of memories, likely
    including (at least) files, host memory, and device memory.  In particular, the
    following properties might be stored:
    
    host_resident_size
    
    compute_resident_size
- - 2009-02-28 17:25:35.863961 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note, in addition to other properties already noted, that it might be
    worthwhile to also recognize file_resident_size, limiting the size of
    file-resident data.
- - 2009-03-04 12:39:37.741453 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - "{file_,host_,compute_}resident_size properties implemented."
git_branch: 
